using System;

namespace LeapCube
{
	public enum axis {
		AXIS_X,
		AXIS_Y,
		AXIS_Z
	}

	public class Draw
	{
		Cube cube;

		public Draw ()
		{
			cube = MainClass.cube;
		}

		public static bool getvoxel(int x, int y, int z)
		{
			if (x >= 0 && x < 8 && y >= 0 && y < 8 && z >= 0 && z < 8) {
				if ((MainClass.cube.frameBuffer [z, y] & (1 << x)) > 0)
					return true;
				else
					return false;
			} else
				return false;
		}

		public static void shift (axis axis, int direction, int min, int max, bool stay)
		{
			// Do not let min or max get out of range.
			if (min < 0 || min > 7 || min > max)
				min = 0;
			if (max < 0 || max > 7 || max < min)
				max = 7;

			int i, x ,y;
			int ii, iii;
			bool state;

			for (i = 0; i < 8; i++)	{
				if (direction == -1) {
					ii = i;
				} else {
					ii = (7-i);
				}	


				for (x = 0; x < 8; x++)	{
					for (y = 0; y <= max; y++) {
						if (direction == -1) {
							iii = ii+1;
						} else {
							iii = ii-1;
						}

						if (axis == axis.AXIS_Z) {
							state = getvoxel(x,y,iii);
							if (stay == true && ii == min) {
								if (state == true)
									altervoxel (x, y, ii, state);
							}
							else 
								altervoxel(x,y,ii,state);
						}

						if (axis == axis.AXIS_Y) {
							state = getvoxel(x,iii,y);
							altervoxel(x,ii,y,state);
						}

						if (axis == axis.AXIS_X) {
							state = getvoxel(iii,y,x);
							altervoxel(ii,y,x,state);
						}
					}
				}
			}

			if (direction == -1)
				i = 8;
			else
				i = 0;

			for (x = 0; x < 8; x++)	{
				for (y = 0; y < 8; y++) {
					if (axis == axis.AXIS_Z)
						MainClass.cube.frameBuffer[i < max ? i : max ,y] &= (byte)(~(1 << x));
						//clrvoxel(x,y,i);

					if (axis == axis.AXIS_Y)
						MainClass.cube.frameBuffer[y,i] &= (byte)(~(1 << x));
						//clrvoxel(x,i,y);

					if (axis == axis.AXIS_X)
						MainClass.cube.frameBuffer[x,y] &= (byte)(~(1 << i));
						//clrvoxel(i,y,x);
				}
			}
		}

		public static void altervoxel(int x, int y, int z, bool state)
		{
			if (state)
			{
				MainClass.cube.frameBuffer[z,y] |= (byte)((1 << x));

			} else
			{
				MainClass.cube.frameBuffer[z,y] &= (byte)(~(1 << x));
			}
		}

		public static void setplane_z (int z)
		{
			int i;
			if (z>=0 && z<8)
			{
				for (i=0;i<8;i++)
					MainClass.cube.frameBuffer[z,i] = 0xff;
			}
		}


		public static void clearplane_z (int z)
		{
			int i;
			if (z>=0 && z<8)
			{
				for (i=0;i<8;i++)
					MainClass.cube.frameBuffer[z,i] = 0x00;
			}
		}

	}
}