using System;

namespace LeapCube
{

	public class Graphx3D
	{

		public Graphx3D ()
		{
		}

		public static Vertex Rotate (Vertex v, axis axis, float angle) {

			Vertex vRot;
			angle = (float)(angle * Math.PI * 0.0055555556f); // convert deg to rad

			if (axis == axis.AXIS_X) {
				vRot = new Vertex (
					(float)(v.x),
					(float)(Math.Cos (angle) * v.y - Math.Sin (angle) * v.z),
					(float)(Math.Sin (angle) * v.y + Math.Cos (angle) * v.z));
			} else if (axis == axis.AXIS_Y) {
				vRot = new Vertex (
					(float)(Math.Cos (angle) * (v.x -1) + Math.Sin (angle) * (v.z -1)), 
					(float)(v.y),
					(float)(-Math.Sin (angle) * (v.x -1) + Math.Cos (angle) * (v.z -1)));
			} else if (axis == axis.AXIS_Z) {
				vRot = new Vertex (
					(float)(Math.Cos (angle) * (v.x -1) - Math.Sin (angle) * (v.y -1)), 
					(float)(Math.Sin (angle) * (v.x -1) + Math.Cos (angle) * (v.y -1)),
					(float)(v.z));
			} else
				vRot = new Vertex (0, 0, 0);

			return vRot;
		}

		public static Vertex Rotate (Vertex v, Vertex rot) {
			Vertex vRot = new Vertex ();
			vRot = Rotate(v, axis.AXIS_X, rot.x);
			vRot = Rotate(vRot, axis.AXIS_Y, rot.y);
			vRot = Rotate(vRot, axis.AXIS_Z, rot.z);
			return vRot;
		}
	}
}

