using System;
using System.IO;
using System.Collections.Generic;
using System.Globalization;

namespace LeapCube
{
	public class MeshImporter
	{

		public static Mesh Import(string fileName) {

			List<Vertex> vertices = new List<Vertex> ();

			// Open the file into a StreamReader
			StreamReader file = File.OpenText(fileName);
			string s = file.ReadToEnd();
			file.Close();

			// Split file into vertices and add them to the mesh
			String[] lines = s.Split('\n');

			foreach (String line in lines) {
				if (line.StartsWith("v ")) {
					String[] args = line.Split (' ');
					vertices.Add(new Vertex(float.Parse(args[1], CultureInfo.InvariantCulture) * 1000000, float.Parse(args[2], CultureInfo.InvariantCulture) * 1000000, float.Parse(args[3], CultureInfo.InvariantCulture) * 1000000));
//					Console.WriteLine(float.Parse(args[1], CultureInfo.InvariantCulture)+":"+float.Parse(args[2], CultureInfo.InvariantCulture)+":"+float.Parse(args[3], CultureInfo.InvariantCulture));
				}
			}


			return new Mesh(vertices, 1.0f, 4,4,4,0,0,0);
		}

	}
}

