using System;
using System.IO.Ports;
using System.Threading;
using Leap;



namespace LeapCube
{

	class MainClass
	{
		static Boolean run = true;
		//static SerialPort _serialPort;
		static String _portName = "/dev/ttyUSB0";
		//static String _portName = "/dev/tnt1";
		static int _portBaudRate = 38400;
		static Parity _parity = Parity.None;
		//static int _dataBits;
		static StopBits _stopBits = StopBits.One; 
		//static Handshake _handshake; 
		public static Cube cube;

		public static int minDistance = 200;

		private static LeapListener listener;
		private static Controller controller;

		public static void Main (string[] args)
		{
			cube = new Cube ();
			//_serialPort = new SerialPort();

			cube.serialPort.PortName = _portName; //virtual test port;
			cube.serialPort.BaudRate = _portBaudRate;
			cube.serialPort.Parity = _parity;
			cube.serialPort.StopBits = _stopBits; 
			// Set the read/write timeouts
			cube.serialPort.ReadTimeout = 500;
			cube.serialPort.WriteTimeout = 500;

			cube.Connect ();

			MainClass main = new MainClass ();
			#if DEBUG
			Console.WriteLine ("Getting serial ports.");
			main.GetSerialPorts ();
			#endif
			// Leap Motion part

			// Create a sample listener and controller
			listener = new LeapListener ();
			controller = new Controller ();

			// Have the listener receive events from the controller
			controller.AddListener (listener);

			Console.WriteLine ("Press enter to quit.");
			// Keep this process running until Enter is pressed
			//Console.WriteLine ("Press Enter to quit...");
			while (run) {
				var input = Console.ReadLine ();
		
				if (input == "") {
					Quit ();
				}
			}
		}

		public static void Quit () {
			// Remove the sample listener when done
			controller.RemoveListener (listener);
			controller.Dispose ();

			//readThread.Join();
			cube.Disconnect ();
			run = false;
		}

		private void GetSerialPorts() 
		{
			string[] ArrayComPortsNames = null;
			int index = -1;
			string ComPortName = null;

			ArrayComPortsNames = SerialPort.GetPortNames();
			do
			{
				index += 1;
				//rtbIncoming.Text += ArrayComPortsNames[index]+"\n";
				Console.WriteLine(ArrayComPortsNames[index]);
			}
			while (!((ArrayComPortsNames[index] == ComPortName) ||
			         (index == ArrayComPortsNames.GetUpperBound(0))));

		}
	}
}